var sfp_col = ['id', 'addr', 'bytes', 'name', 'value', 'meaning'];

var sfp_a0 = [
  { addr: 0, bytes: 1, name: "Identifier", desc: "Type of transceiver", type: "list",
    info: [
      {min: 0x00, max: 0x00, desc: "Unknown or unspecified"},
      {min: 0x01, max: 0x01, desc: "GBIC"},
      {min: 0x02, max: 0x02, desc: "Module soldered to motherboard (ex: SFF)"},
      {min: 0x03, max: 0x03, desc: "SFP or SFP+"},
      {min: 0x04, max: 0x7F, desc: "Not used by this specification. These values are maintained in the Transceiver Management section of SFF-8024."},
      {min: 0x80, max: 0xFF, desc: "Vendor specific"}]
  },
  { addr: 1, bytes: 1, name: "Ext. Identifier", desc: "Extended identifier of type of transceiver", type: "list",
    info: [
      {min: 0x00, max: 0x00, desc: "GBIC definition is not specified or the GBIC definition is not compliant with a defined MOD_DEF. See product specification for details."},
      {min: 0x01, max: 0x01, desc: "GBIC is compliant with MOD_DEF 1"},
      {min: 0x02, max: 0x02, desc: "GBIC is compliant with MOD_DEF 2"},
      {min: 0x03, max: 0x03, desc: "GBIC is compliant with MOD_DEF 3"},
      {min: 0x04, max: 0x04, desc: "GBIC/SFP function is defined by two-wire interface ID only"},
      {min: 0x05, max: 0x05, desc: "GBIC is compliant with MOD_DEF 5"},
      {min: 0x06, max: 0x06, desc: "GBIC is compliant with MOD_DEF 6"},
      {min: 0x07, max: 0x07, desc: "GBIC is compliant with MOD_DEF 7"},
      {min: 0x08, max: 0xFF, desc: "Unallocated"}]
  },
  { addr: 2, bytes: 1, name: "Connector", desc: "Code for connector type (see SFF-8024 Transceiver Management)", type: "list",
    info: [
      {min: 0x00, max: 0x00, desc: "Unknown or unspecified"},
      {min: 0x01, max: 0x01, desc: "SC (Subscriber Connector)"},
      {min: 0x02, max: 0x02, desc: "Fibre Channel Style 1 copper connector"},
      {min: 0x03, max: 0x03, desc: "Fibre Channel Style 2 copper connector"},
      {min: 0x04, max: 0x04, desc: "BNC/TNC (Bayonet/Threaded Neill-Concelman)"},
      {min: 0x05, max: 0x05, desc: "Fibre Channel coax headers"},
      {min: 0x06, max: 0x06, desc: "Fiber Jack"},
      {min: 0x07, max: 0x07, desc: "LC (Lucent Connector)"},
      {min: 0x08, max: 0x08, desc: "MT-RJ (Mechanical Transfer – Registered Jack)"},
      {min: 0x09, max: 0x09, desc: "MU (Multiple Optical)"},
      {min: 0x0A, max: 0x0A, desc: "SG"},
      {min: 0x0B, max: 0x0B, desc: "Optical Pigtail"},
      {min: 0x0C, max: 0x0C, desc: "MPO 1x12 (Multifiber Parallel Optic)"},
      {min: 0x0D, max: 0x0D, desc: "MPO 2x16"},
      {min: 0x0E, max: 0x1F, desc: "Reserved"},
      {min: 0x20, max: 0x20, desc: "HSSDC II (High Speed Serial Data Connector)"},
      {min: 0x21, max: 0x21, desc: "Copper pigtail"},
      {min: 0x22, max: 0x22, desc: "RJ45 (Registered Jack)"},
      {min: 0x23, max: 0x23, desc: "No separable connector"},
      {min: 0x24, max: 0x24, desc: "MXC 2x16"},
      {min: 0x25, max: 0x25, desc: "CS optical connector"},
      {min: 0x26, max: 0x26, desc: "SN (previously Mini CS) optical connector"},
      {min: 0x27, max: 0x27, desc: "MPO 2x12"},
      {min: 0x28, max: 0x28, desc: "MPO 1x16"},
      {min: 0x29, max: 0x7F, desc: "Reserved"},
      {min: 0x80, max: 0xFF, desc: "Vendor specific"}]
  },
  { addr: 3, bytes: 8, name: "Transceiver", desc: "Code for electronic or optical compatibility", type: "bits",
    info: [
      {byte_id: -1, desc: "10G Ethernet Compliance Codes"},

      {byte_id: 0, bit_id: 7, desc: "10G Base-ER"},
      {byte_id: 0, bit_id: 6, desc: "10G Base-LRM"},
      {byte_id: 0, bit_id: 5, desc: "10G Base-LR"},
      {byte_id: 0, bit_id: 4, desc: "10G Base-SR"},

      {byte_id: -1, desc: "Infiniband Compliance Codes"},

      {byte_id: 0, bit_id: 3, desc: "1X SX"},
      {byte_id: 0, bit_id: 2, desc: "1X LX"},
      {byte_id: 0, bit_id: 1, desc: "1X Copper Active"},
      {byte_id: 0, bit_id: 0, desc: "1X Copper Passive"},

      {byte_id: -1, desc: "ESCON Compliance Codes"},

      {byte_id: 1, bit_id: 7, desc: "ESCON MMF, 1310nm LED"},
      {byte_id: 1, bit_id: 6, desc: "ESCON SMF, 1310nm Laser"},

      {byte_id: -1, desc: "SONET Compliance Codes"},

      {byte_id: 1, bit_id: 5, desc: "OC-192, short reach *2"},
      {byte_id: 1, bit_id: 4, desc: "SONET reach specifier bit 1"},
      {byte_id: 1, bit_id: 3, desc: "SONET reach specifier bit 2"},
      {byte_id: 1, bit_id: 2, desc: "OC-48, long reach*2"},
      {byte_id: 1, bit_id: 1, desc: "OC-48, intermediate reach *2"},
      {byte_id: 1, bit_id: 0, desc: "OC-48, short reach *2"},

      {byte_id: 2, bit_id: 7, desc: "Unallocated"},
      {byte_id: 2, bit_id: 6, desc: "OC-12, single mode, long reach *2"},
      {byte_id: 2, bit_id: 5, desc: "OC-12, single mode, inter. reach *2"},
      {byte_id: 2, bit_id: 4, desc: "OC-12, short reach *2"},
      {byte_id: 2, bit_id: 3, desc: "Unallocated"},
      {byte_id: 2, bit_id: 2, desc: "OC-3, single mode, long reach *2"},
      {byte_id: 2, bit_id: 1, desc: "OC-3, single mode, inter. reach *2"},
      {byte_id: 2, bit_id: 0, desc: "OC-3, short reach *2"},

      {byte_id: -1, desc: "Ethernet Compliance Codes"},

      {byte_id: 3, bit_id: 7, desc: "BASE-PX *3"},
      {byte_id: 3, bit_id: 6, desc: "BASE-BX10 *3"},
      {byte_id: 3, bit_id: 5, desc: "100BASE-FX"},
      {byte_id: 3, bit_id: 4, desc: "100BASE-LX/LX10"},
      {byte_id: 3, bit_id: 3, desc: "1000BASE-T"},
      {byte_id: 3, bit_id: 2, desc: "1000BASE-CX"},
      {byte_id: 3, bit_id: 1, desc: "1000BASE-LX *3"},
      {byte_id: 3, bit_id: 0, desc: "1000BASE-SX"},

      {byte_id: -1, desc: "Fibre Channel Link Length"},

      {byte_id: 4, bit_id: 7, desc: "very long distance (V)"},
      {byte_id: 4, bit_id: 6, desc: "short distance (S)"},
      {byte_id: 4, bit_id: 5, desc: "intermediate distance (I)"},
      {byte_id: 4, bit_id: 4, desc: "long distance (L)"},
      {byte_id: 4, bit_id: 3, desc: "medium distance (M)"},

      {byte_id: -1, desc: "Fibre Channel Technology"},

      {byte_id: 4, bit_id: 2, desc: "Shortwave laser, linear Rx (SA) *7"},
      {byte_id: 4, bit_id: 1, desc: "Longwave laser (LC) *6"},
      {byte_id: 4, bit_id: 0, desc: "Electrical inter-enclosure (EL)"},

      {byte_id: 5, bit_id: 7, desc: "Electrical intra-enclosure (EL)"},
      {byte_id: 5, bit_id: 6, desc: "Shortwave laser w/o OFC (SN) *7"},
      {byte_id: 5, bit_id: 5, desc: "Shortwave laser with OFC (SL) *4"},
      {byte_id: 5, bit_id: 4, desc: "Longwave laser (LL) *5"},

      {byte_id: -1, desc: "SFP+ Cable Technology"},

      {byte_id: 5, bit_id: 3, desc: "Active Cable *8"},
      {byte_id: 5, bit_id: 2, desc: "Passive Cable *8"},
      {byte_id: 5, bit_id: 1, desc: "Unallocated"},
      {byte_id: 5, bit_id: 0, desc: "Unallocated"},

      {byte_id: -1, desc: "Fibre Channel Transmission Media"},

      {byte_id: 6, bit_id: 7, desc: "Twin Axial Pair (TW)"},
      {byte_id: 6, bit_id: 6, desc: "Twisted Pair (TP)"},
      {byte_id: 6, bit_id: 5, desc: "Miniature Coax (MI)"},
      {byte_id: 6, bit_id: 4, desc: "Video Coax (TV)"},
      {byte_id: 6, bit_id: 3, desc: "Multimode, 62.5um (M6)"},
      {byte_id: 6, bit_id: 2, desc: "Multimode, 50um (M5, M5E)"},
      {byte_id: 6, bit_id: 1, desc: "Unallocated"},
      {byte_id: 6, bit_id: 0, desc: "Single Mode (SM)"},

      {byte_id: -1, desc: "Fibre Channel Speed"},

      {byte_id: 7, bit_id: 7, desc: "1200 MBytes/sec"},
      {byte_id: 7, bit_id: 6, desc: "800 MBytes/sec"},
      {byte_id: 7, bit_id: 5, desc: "1600 MBytes/sec"},
      {byte_id: 7, bit_id: 4, desc: "400 MBytes/sec"},
      {byte_id: 7, bit_id: 3, desc: "3200 MBytes/sec"},
      {byte_id: 7, bit_id: 2, desc: "200 MBytes/sec"},
      {byte_id: 7, bit_id: 1, desc: "See byte 36 extended compliance code"},
      {byte_id: 7, bit_id: 0, desc: "100 MBytes/sec"}
    ]
  },
  { addr: 11, bytes: 1, name: "Encoding",
    desc: "Code for high speed serial encoding algorithm (see SFF-8024 Transceiver Management)", type: "list",
    info: [
      {min: 0x00, max: 0x00, desc: "Unspecified"},
      {min: 0x01, max: 0x01, desc: "8B/10B"},
      {min: 0x02, max: 0x02, desc: "4B/5B"},
      {min: 0x03, max: 0x03, desc: "NRZ"},
      {min: 0x04, max: 0x04, desc: "Manchester (8472) / SONET Scrambled (8436/8636)"},
      {min: 0x05, max: 0x05, desc: "SONET Scrambled (8472) / 64B/66B (8436/8636)"},
      {min: 0x06, max: 0x06, desc: "64B/66B (8472) / Manchester ((8436/8636))"},
      {min: 0x07, max: 0x07, desc: "256B/257B (transcoded FEC-enabled data)"},
      {min: 0x08, max: 0x08, desc: "PAM4"},
      {min: 0x09, max: 0xFF, desc: "Reserved"}]
  },
  { addr: 12, bytes: 1, name: "BR, Nominal",
    desc: "Nominal signalling rate, units of 100 MBd. (see details for rates > 25.4 Gb/s)", type: "unit",
    info: {unit: "Mbd", multiplier: "100", sign: 0}
  },
  { addr: 13, bytes: 1, name: "Rate Identifier",
    desc: "Type of rate select functionality", type: "list",
    info: [
      {min: 0x00, max: 0x00, desc: "Unspecified"},
      {min: 0x01, max: 0x01, desc: "SFF-8079 (4/2/1G Rate_Select & AS0/AS1)"},
      {min: 0x02, max: 0x02, desc: "SFF-8431 (8/4/2G Rx Rate_Select only)"},
      {min: 0x03, max: 0x03, desc: "Unspecified"},
      {min: 0x04, max: 0x04, desc: "SFF-8431 (8/4/2G Tx Rate_Select only)"},
      {min: 0x05, max: 0x05, desc: "Unspecified"},
      {min: 0x06, max: 0x06, desc: "SFF-8431 (8/4/2G Independent Rx & Tx Rate_select)"},
      {min: 0x07, max: 0x07, desc: "Unspecified"},
      {min: 0x08, max: 0x08, desc: "FC-PI-5 (16/8/4G Rx Rate_select only) High=16G only, Low=8G/4G"},
      {min: 0x09, max: 0x09, desc: "Unspecified"},
      {min: 0x0A, max: 0x0A, desc: "FC-PI-5 (16/8/4G Independent Rx, Tx Rate_select) High=16G only, Low=8G/4G"},
      {min: 0x0B, max: 0x0B, desc: "Unspecified"},
      {min: 0x0C, max: 0x0C, desc: "FC-PI-6 (32/16/8G Independent Rx, Tx Rate_Select) High=32G only, Low = 16G/8G"},
      {min: 0x0D, max: 0x0D, desc: "Unspecified"},
      {min: 0x0E, max: 0x0E, desc: "10/8G Rx and Tx Rate_Select controlling the operation or locking modes of the internal signal conditioner, retimer or CDR, according to the logic table defined in Table 10-2, High Bit Rate (10G) =9.95-11.3 Gb/s; Low Bit Rate (8G) = 8.5 Gb/s. In this mode, the default value of bit 110.3 (Soft Rate Select RS(0), Table 9-11) and of bit 118.3 (Soft Rate Select RS(1), Table 10-1) is 1."},
      {min: 0x0F, max: 0x0F, desc: "Unspecified"},
      {min: 0x10, max: 0x10, desc: "FC-PI-7 (64/32/16G Independent Rx, Tx Rate Select) High = 32GFC and 64GFC. Low = 16GFC."},
      {min: 0x11, max: 0x11, desc: "Unspecified"},
      {min: 0x12, max: 0xFF, desc: "Unspecified"}]
  },
  { addr: 14, bytes: 1, name: "Length(SMF,km)",
    desc: "Link length supported for single mode fiber, units of km", type: "unit",
    info: {unit: "km", multiplier: "1", sign: 0}
  },
  { addr: 15, bytes: 1, name: "Length(SMF)",
    desc: "Link length supported for single mode fiber, units of 100 m", type: "unit",
    info: {unit: "m", multiplier: "100", sign: 0}
  },
  { addr: 16, bytes: 1, name: "Length(SMF,50um)",
    desc: "Link length supported for 50 um OM2 fiber, units of 10 m", type: "unit",
    info: {unit: "m", multiplier: "10", sign: 0}
  },
  { addr: 17, bytes: 1, name: "Length(SMF,62.5um)",
    desc: "Link length supported for 62.5 um OM1 fiber, units of 10 m", type: "unit",
    info: {unit: "m", multiplier: "10", sign: 0}
  },
  { addr: 18, bytes: 1, name: "Length (OM4 or copper cable)",
    desc: "Link length supported for 50um OM4 fiber, units of 10m. Alternatively copper or direct attach cable, units of m",
    type: "unit",
    info: {unit: "m", multiplier: "10", sign: 0}
  },
  { addr: 19, bytes: 1, name: "Length (OM3)",
    desc: "Link length supported for 50 um OM3 fiber, units of 10 m", type: "unit",
    info: {unit: "m", multiplier: "10", sign: 0}
  },
  { addr: 20, bytes: 16, name: "Vendor name",
    desc: "SFP vendor name (ASCII)", type: "ASCII",
    info: {}
  },
  { addr: 36, bytes: 1, name: "Transceiver",
    desc: "Code for electronic or optical compatibility", type: "list",
    info: [
      {min: 0x0, max: 0x0, desc: "Unspecified"},
      {min: 0x1, max: 0x1, desc: "100G AOC (Active Optical Cable) or 25GAUI C2M AOC. Providing a worst BER of 5 × 10 -5"},
      {min: 0x2, max: 0x2, desc: "100GBASE-SR4 or 25GBASE-SR"},
      {min: 0x3, max: 0x3, desc: "100GBASE-LR4 or 25GBASE-LR"},
      {min: 0x4, max: 0x4, desc: "100GBASE-ER4 or 25GBASE-ER"},
      {min: 0x5, max: 0x5, desc: "100GBASE-SR10"},
      {min: 0x6, max: 0x6, desc: "100G CWDM4"},
      {min: 0x7, max: 0x7, desc: "100G PSM4 Parallel SMF"},
      {min: 0x8, max: 0x8, desc: "100G ACC (Active Copper Cable) or 25GAUI C2M ACC. Providing a worst BER of 5 × 10 -5"},
      {min: 0x9, max: 0x9, desc: "Obsolete (assigned before 100G CWDM4 MSA required FEC)"},
      {min: 0x10, max: 0x10, desc: "Reserved"},
      {min: 0x11, max: 0x11, desc: "100GBASE-CR4, 25GBASE-CR CA-25G-L or 50GBASE-CR2 with RS (Clause91) FEC"},
      {min: 0x12, max: 0x12, desc: "25GBASE-CR CA-25G-S or 50GBASE-CR2 with BASE-R (Clause 74 Fire code) FEC"},
      {min: 0x13, max: 0x13, desc: "25GBASE-CR CA-25G-N or 50GBASE-CR2 with no FEC"},
      {min: 0x14, max: 0x14, desc: "10 Mb/s Single Pair Ethernet (802.3cg, Clause 146/147, 1000 m copper)"},
      {min: 0x15, max: 0x15, desc: "Reserved"},
      {min: 0x16, max: 0x16, desc: "40GBASE-ER4"},
      {min: 0x17, max: 0x17, desc: "4 x 10GBASE-SR"},
      {min: 0x18, max: 0x18, desc: "40G PSM4 Parallel SMF"},
      {min: 0x19, max: 0x19, desc: "G959.1 profile P1I1-2D1 (10709 MBd, 2km, 1310 nm SM)"},
      {min: 0x20, max: 0x20, desc: "G959.1 profile P1S1-2D2 (10709 MBd, 40km, 1550 nm SM)"},
      {min: 0x21, max: 0x21, desc: "G959.1 profile P1L1-2D2 (10709 MBd, 80km, 1550 nm SM)"},
      {min: 0x22, max: 0x22, desc: "10GBASE-T with SFI electrical interface"},
      {min: 0x23, max: 0x23, desc: "100G CLR4"},
      {min: 0x24, max: 0x24, desc: "100G AOC or 25GAUI C2M AOC. Providing a worst BER of 10 -12 or below"},
      {min: 0x25, max: 0x25, desc: "100G ACC or 25GAUI C2M ACC. Providing a worst BER of 10 -12 or below"},
      {min: 0x26, max: 0x26, desc: "100GE-DWDM2 (DWDM transceiver using 2 wavelengths on a 1550 nm DWDM grid with a reach up to 80 km)"},
      {min: 0x27, max: 0x27, desc: "100G 1550nm WDM (4 wavelengths)"},
      {min: 0x28, max: 0x28, desc: "10GBASE-T Short Reach (30 meters)"},
      {min: 0x29, max: 0x29, desc: "5GBASE-T"},
      {min: 0x30, max: 0x30, desc: "2.5GBASE-T"},
      {min: 0x31, max: 0x31, desc: "40G SWDM4"},
      {min: 0x32, max: 0x32, desc: "100G SWDM4"},
      {min: 0x33, max: 0x33, desc: "100G PAM4 BiDi"},
      {min: 0x34, max: 0x34, desc: "4WDM-10 MSA (10km version of 100G CWDM4 with same RS(528,514) FEC in host system)"},
      {min: 0x35, max: 0x35, desc: "4WDM-20 MSA (20km version of 100GBASE-LR4 with RS(528,514) FEC in host system)"},
      {min: 0x36, max: 0x36, desc: "4WDM-40 MSA (40km reach with APD receiver and RS(528,514) FEC in host system)"},
      {min: 0x37, max: 0x37, desc: "100GBASE-DR (Clause 140), CAUI-4 (no FEC)"},
      {min: 0x38, max: 0x38, desc: "100G-FR or 100GBASE-FR1 (Clause 140), CAUI-4 (no FEC)"},
      {min: 0x39, max: 0x39, desc: "100G-LR or 100GBASE-LR1 (Clause 140), CAUI-4 (no FEC)"},
      {min: 0x40, max: 0x40, desc: "100G-SR1 (P802.3db, Clause tbd), CAUI-4 (no FEC)"},
      {min: 0x41, max: 0x41, desc: "100GBASE-SR1, 200GBASE-SR2 or 400GBASE-SR4 (P802.3db, Clause tbd)"},
      {min: 0x42, max: 0x42, desc: "100GBASE-FR1 (P802.3cu, Clause 140)"},
      {min: 0x43, max: 0x43, desc: "100GBASE-LR1 (P802.3cu, Clause 140)"},
      {min: 0x44, max: 0x47, desc: "Reserved"},
      {min: 0x48, max: 0x48, desc: "Active Copper Cable with 50GAUI, 100GAUI-2 or 200GAUI-4 C2M. Providing a worst BER of 10 -6 or below"},
      {min: 0x49, max: 0x49, desc: "Active Optical Cable with 50GAUI, 100GAUI-2 or 200GAUI-4 C2M. Providing a worst BER of 10 -6 or below"},
      {min: 0x50, max: 0x50, desc: "Active Copper Cable with 50GAUI, 100GAUI-2 or 200GAUI-4 C2M. Providing a worst BER of 2.6x10 -4 for ACC, 10 -5 for AUI, or below"},
      {min: 0x51, max: 0x51, desc: "Active Optical Cable with 50GAUI, 100GAUI-2 or 200GAUI-4 C2M. Providing a worst BER of 2.6x10 -4 for AOC, 10 -5 for AUI, or below"},
      {min: 0x52, max: 0x62, desc: "Reserved"},
      {min: 0x63, max: 0x63, desc: "100GBASE-CR1, 200GBASE-CR2 or 400GBASE-CR4 (P802.3ck, Clause 162)"},
      {min: 0x64, max: 0x64, desc: "50GBASE-CR, 100GBASE-CR2, or 200GBASE-CR4"},
      {min: 0x65, max: 0x65, desc: "50GBASE-SR, 100GBASE-SR2, or 200GBASE-SR4"},
      {min: 0x66, max: 0x66, desc: "50GBASE-FR or 200GBASE-DR4"},
      {min: 0x67, max: 0x67, desc: "200GBASE-FR4"},
      {min: 0x68, max: 0x68, desc: "200G 1550 nm PSM4"},
      {min: 0x69, max: 0x69, desc: "50GBASE-LR"},
      {min: 0x70, max: 0x70, desc: "200GBASE-LR4"},
      {min: 0x71, max: 0x71, desc: "400GBASE-DR4 (802.3, Clause 124), 100GAUI-1 C2M (Annex 120G)"},
      {min: 0x72, max: 0x72, desc: "400GBASE-FR4 (802.3cu, Clause 151)"},
      {min: 0x73, max: 0x73, desc: "400GBASE-LR4-6 (802.3cu, Clause 151)"},
      {min: 0x74, max: 0x126, desc: "Reserved"},
      {min: 0x127, max: 0x127, desc: "256GFC-SW4 (FC-PI-7P)"},
      {min: 0x128, max: 0x128, desc: "Capable of 64GFC (FC-PI-7)"},
      {min: 0x129, max: 0x129, desc: "Capable of 128GFC (FC-PI-8)"},
      {min: 0x130, max: 0x159, desc: "Reserved for future FC rates"},
      {min: 0x160, max: 0x255, desc: "Reserved"}]
  },
  { addr: 37, bytes: 3, name: "Vendor OUI",
    desc: "SFP vendor IEEE company ID", type: "OUI",
    info: {}
  },
  { addr: 40, bytes: 16, name: "Vendor PN",
    desc: "Part number provided by SFP vendor (ASCII)", type: "ASCII",
    info: {}
  },
  { addr: 56, bytes: 4, name: "Vendor rev",
    desc: "Revision level for part number provided by vendor (ASCII)", type: "ASCII",
    info: {}
  },
  { addr: 60, bytes: 2, name: "Wavelength",
    desc: "Laser wavelength (Passive/Active Cable Specification Compliance)", type: "unit",
    info: {unit: "nm", multiplier: "1", sign: 0}
  },
  { addr: 62, bytes: 1, name: "Unallocated", desc: "", type: "raw", info: {}},
  { addr: 63, bytes: 1, name: "CC_BASE", desc: "Check code for Base ID Fields (addresses 0 to 62)", type: "raw", info: {}},
  { addr: 64, bytes: 2, name: "Options", desc: "Indicates which optional transceiver signals are implemented", type: "bits",
    info: [
      {byte_id: 0, bit_id: 7, desc: "Unallocated"},
      {byte_id: 0, bit_id: 6, desc: "Unallocated"},
      {byte_id: 0, bit_id: 5, desc: "High Power Level Declaration",
       det: "(see SFF-8431 Addendum) Value of zero identifies standard Power Levels 1 and 2 as indicated by bit 1. Value of one identifies Power Level 3 requirement."},
      {byte_id: 0, bit_id: 4, desc: "Paging implemented indicator.",
       det: "A value of 1 indicates that paging is implemented and byte 127d of device address A2h is used for page selection."},
      {byte_id: 0, bit_id: 3, desc: "Retimer or CDR indicator.",
       det: "A value of 1 indicates that the transceiver has an internal retimer or Clock and Data Recovery (CDR) circuit."},
      {byte_id: 0, bit_id: 2, desc: "Cooled Transceiver Declaration",
       det: "(see SFF-8431). Value of zero identifies a conventional uncooled (or unspecified) laser implementation. Value of one identifies a cooled laser transmitter implementation."},
      {byte_id: 0, bit_id: 1, desc: "Power Level Declaration",
       det: "(see SFF-8431). Value of zero identifies Power Level 1 (or unspecified) requirements. Value of one identifies Power Level 2 requirement. See Table 8-7 and Table 10-1 for control, status, timing. See Bit 5 for Power Level 3 declaration."},
      {byte_id: 0, bit_id: 0, desc: "Linear Receiver Output Implemented",
       det: "(see SFF-8431). Value of zero identifies a conventional limiting (or unspecified) receiver output. Value of one identifies a linear receiver output."},

      {byte_id: 1, bit_id: 7, desc: "Receiver decision threshold implemented.",
       det: "A value of 1 indicates that RDT is implemented."},
      {byte_id: 1, bit_id: 6, desc: "Tunable transmitter technology.", 
       det: "A value of 1 indicates that the transmitter wavelength/frequency istunable in accordance with SFF-8690."},
      {byte_id: 1, bit_id: 5, desc: "RATE_SELECT functionality is implemented",
       det: "NOTE: Lack of implementation does not indicate lack of simultaneous compliance with multiple standard rates. Compliance with particular standards should be determined from Transceiver Code Section (Table 5-3). Refer to Table 5-6 for Rate_Select functionality type identifiers."},
      {byte_id: 1, bit_id: 4, desc: "TX_DISABLE is implemented",
       det: " and disables the high speed serial output."},
      {byte_id: 1, bit_id: 3, desc: "TX_FAULT signal implemented.",
       det: "(See SFP MSA)"},
      {byte_id: 1, bit_id: 2, desc: "Loss of Signal implemented",
       det: "signal inverted from standard definition in SFP MSA (often called 'Signal Detect'). NOTE: This is not standard SFP/GBIC behavior and should be avoided, since non-interoperable behavior results."},
      {byte_id: 1, bit_id: 1, desc: "Loss of Signal implemented",
       det: "signal as defined in SFP MSA (often called 'Rx_LOS')."},
      {byte_id: 1, bit_id: 0, desc: "Unallocated"}]
  },
  { addr: 66, bytes: 1, name: "BR, max",
    desc: "Upper bit rate margin, units of % (see details for rates > 25.4 Gb/s)", type: "unit",
    info: {unit: "%", multiplier: "1", sign: 0}
  },
  { addr: 67, bytes: 1, name: "BR, min",
    desc: "Lower bit rate margin, units of % (see details for rates > 25.4 Gb/s)", type: "unit",
    info: {unit: "%", multiplier: "1", sign: 0}
  },
  { addr: 68, bytes: 16, name: "Vendor SN",
    desc: "Serial number provided by vendor (ASCII)", type: "ASCII",
    info: {}
  },
  { addr: 84, bytes: 8, name: "Date code",
    desc: "Vendor's manufacturing date code", type: "date",
    info: ["ASCII code, two low order digits of year. (00 = 2000).",
           "ASCII code, digits of month (01 = Jan through 12 = Dec)",
           "ASCII code, day of month (01-31)",
           "vendor specific lot code, may be blank"]
  },
  { addr: 92, bytes: 1, name: "Diagnostic Monitoring Type", desc: "Indicates which type of diagnostic monitoring is implemented (if any) in the transceiver", type: "bits",
    info: [
      {byte_id: 0, bit_id: 7, desc: "Reserved",
       det: " for legacy diagnostic implementations. Must be '0' for compliance with this document."},
      {byte_id: 0, bit_id: 6, desc: "Digital diagnostic monitoring implemented",
       det: " (described in this document). Must be '1' for compliance with this document."},
      {byte_id: 0, bit_id: 5, desc: "Internally calibrated"},
      {byte_id: 0, bit_id: 4, desc: "Externally calibrated"},
      {byte_id: 0, bit_id: 3, desc: "Received power measurement",
       det: "type 0 = OMA, 1 = average power"},
      {byte_id: 0, bit_id: 2, desc: "Address change required",
       det: "see section above, 'addressing modes'"},
      {byte_id: 0, bit_id: 1, desc: "Unallocated"},
      {byte_id: 0, bit_id: 0, desc: "Unallocated"}]
  },
  { addr: 93, bytes: 1, name: "Enhanced Options",
    desc: "Indicates which optional enhanced features are implemented (if any) in the transceiver", type: "bits",
    info: [
      {byte_id: 0, bit_id: 7, desc: "Optional alarm/warning flags implemented",
       det: " for all monitored quantities"},
      {byte_id: 0, bit_id: 6, desc: "Optional soft TX_DISABLE implemented",
       det: "control and monitoring implemented"},
      {byte_id: 0, bit_id: 5, desc: "Optional soft TX_FAULT monitoring implemented"},
      {byte_id: 0, bit_id: 4, desc: "Optional soft RX_LOS monitoring implemented"},
      {byte_id: 0, bit_id: 3, desc: "Optional soft RATE_SELECT control and monitoring implemented"},
      {byte_id: 0, bit_id: 2, desc: "Optional Application Select control implemented per SFF-8079"},
      {byte_id: 0, bit_id: 1, desc: "Optional soft Rate Select control implemented per SFF-8431"},
      {byte_id: 0, bit_id: 0, desc: "Unallocated"}]
  },
  { addr: 94, bytes: 1, name: "SFF-8472 Compliance", desc: "Indicates which revision of SFF-8472 the transceiver complies with.",
    type: "list", info: [
      {min: 0x1, max: 0x1, desc: "Includes functionality described in Rev 9.3 of SFF-8472."},
      {min: 0x2, max: 0x2, desc: "Includes functionality described in Rev 9.5 of SFF-8472."},
      {min: 0x3, max: 0x3, desc: "Includes functionality described in Rev 10.2 of SFF-8472."},
      {min: 0x4, max: 0x4, desc: "Includes functionality described in Rev 10.4 of SFF-8472."},
      {min: 0x5, max: 0x5, desc: "Includes functionality described in Rev 11.0 of SFF-8472."},
      {min: 0x6, max: 0x6, desc: "Includes functionality described in Rev 11.3 of SFF-8472."},
      {min: 0x7, max: 0x7, desc: "Includes functionality described in Rev 11.4 of SFF-8472."},
      {min: 0x8, max: 0x8, desc: "Includes functionality described in Rev 12.3 of SFF-8472."},
      {min: 0x9, max: 0x255, desc: "Unallocated"}]
  },
  { addr: 95, bytes: 1, name: "CC_EXT", desc: "Check code for the Extended ID Fields (addresses 64 to 94)", type: "raw", info: {}},
  { addr: 96, bytes: 32, name: "Vendor Specific", desc: "Vendor Specific EEPROM", type: "raw", info: {}},
  { addr: 128, bytes: 128, name: "Reserved", desc: "Reserved for SFF-8079", type: "raw", info: {}},
];

var sfp_a2 = [
  { addr: 0, bytes: 2, name: "Temp High Alarm",
    desc: "", type: "unit",
    info: {unit: "&#xB0;C", sign: 1, multiplier: "0.00390625"}
  },
  { addr: 2, bytes: 2, name: "Temp Low Alarm",
    desc: "", type: "unit",
    info: {unit: "&#xB0;C", sign: 1, multiplier: "0.00390625"}
  },
  { addr: 4, bytes: 2, name: "Temp High Warning",
    desc: "", type: "unit",
    info: {unit: "&#xB0;C", sign: 1, multiplier: "0.00390625"}
  },
  { addr: 6, bytes: 2, name: "Temp Low Warning",
    desc: "", type: "unit",
    info: {unit: "&#xB0;C", sign: 1, multiplier: "0.00390625"}
  },
  { addr: 8, bytes: 2, name: "Voltage High Alarm",
    desc: "", type: "unit",
    info: {unit: "V", sign: 0, multiplier: "0.0001"}
  },
  { addr: 10, bytes: 2, name: "Voltage Low Alarm",
    desc: "", type: "unit",
    info: {unit: "V", sign: 0, multiplier: "0.0001"}
  },
  { addr: 12, bytes: 2, name: "Voltage High Warning",
    desc: "", type: "unit",
    info: {unit: "V", sign: 0, multiplier: "0.0001"}
  },
  { addr: 14, bytes: 2, name: "Voltage Low Warning",
    desc: "", type: "unit",
    info: {unit: "V", sign: 0, multiplier: "0.0001"}
  },
  { addr: 16, bytes: 2, name: "Bias High Alarm",
    desc: "", type: "unit",
    info: {unit: "mA", sign: 0, multiplier: "0.002"}
  },
  { addr: 18, bytes: 2, name: "Bias Low Alarm",
    desc: "", type: "unit",
    info: {unit: "mA", sign: 0, multiplier: "0.002"}
  },
  { addr: 20, bytes: 2, name: "Bias High Warning",
    desc: "", type: "unit",
    info: {unit: "mA", sign: 0, multiplier: "0.002"}
  },
  { addr: 22, bytes: 2, name: "Bias Low Warning",
    desc: "", type: "unit",
    info: {unit: "mA", sign: 0, multiplier: "0.002"}
  },
  { addr: 24, bytes: 2, name: "TX Power High Alarm",
    desc: "", type: "unit",
    info: {unit: "mW", sign: 0, multiplier: "0.0001"}
  },
  { addr: 26, bytes: 2, name: "TX Power Low Alarm",
    desc: "", type: "unit",
    info: {unit: "mW", sign: 0, multiplier: "0.0001"}
  },
  { addr: 28, bytes: 2, name: "TX Power High Warning",
    desc: "", type: "unit",
    info: {unit: "mW", sign: 0, multiplier: "0.0001"}
  },
  { addr: 30, bytes: 2, name: "TX Power Low Warning",
    desc: "", type: "unit",
    info: {unit: "mW", sign: 0, multiplier: "0.0001"}
  },
  { addr: 32, bytes: 2, name: "RX Power High Alarm",
    desc: "", type: "unit",
    info: {unit: "mW", sign: 0, multiplier: "0.0001"}
  },
  { addr: 34, bytes: 2, name: "RX Power Low Alarm",
    desc: "", type: "unit",
    info: {unit: "mW", sign: 0, multiplier: "0.0001"}
  },
  { addr: 36, bytes: 2, name: "RX Power High Warning",
    desc: "", type: "unit",
    info: {unit: "mW", sign: 0, multiplier: "0.0001"}
  },
  { addr: 38, bytes: 2, name: "RX Power Low Warning",
    desc: "", type: "unit",
    info: {unit: "mW", sign: 0, multiplier: "0.0001"}
  },
  { addr: 40, bytes: 2, name: "Optional Laser Temp High Alarm",
    desc: "", type: "unit",
    info: {unit: "&#xB0;C", sign: 1, multiplier: "0.00390625"}
  },
  { addr: 42, bytes: 2, name: "Optional Laser Temp Low Alarm",
    desc: "", type: "unit",
    info: {unit: "&#xB0;C", sign: 1, multiplier: "0.00390625"}
  },
  { addr: 44, bytes: 2, name: "Optional Laser Temp High Warning",
    desc: "", type: "unit",
    info: {unit: "&#xB0;C", sign: 1, multiplier: "0.00390625"}
  },
  { addr: 46, bytes: 2, name: "Optional Laser Temp Low Warning",
    desc: "", type: "unit",
    info: {unit: "&#xB0;C", sign: 1, multiplier: "0.00390625"}
  },
  { addr: 48, bytes: 2, name: "Optional TEC Current High Alarm",
    desc: "", type: "unit",
    info: {unit: "mA", sign: 1, multiplier: "0.1"}
  },
  { addr: 50, bytes: 2, name: "Optional TEC Current Low Alarm",
    desc: "", type: "unit",
    info: {unit: "mA", sign: 1, multiplier: "0.1"}
  },
  { addr: 52, bytes: 2, name: "Optional TEC Current High Warning",
    desc: "", type: "unit",
    info: {unit: "mA", sign: 1, multiplier: "0.1"}
  },
  { addr: 54, bytes: 2, name: "Optional TEC Current Low Warning",
    desc: "", type: "unit",
    info: {unit: "mA", sign: 1, multiplier: "0.1"}
  },
  { addr: 56, bytes: 4, name: "Rx_PWR(4)",
    desc: "Single precision floating point calibration data - Rx optical power. Bit 7 of byte 56 is MSB. Bit 0 of byte 59 is LSB. Rx_PWR(4) should be set to zero for 'internally calibrated' devices.",
    type: "raw", info: {}},
  { addr: 60, bytes: 4, name: "Rx_PWR(3)",
    desc: "Single precision floating point calibration data - Rx optical power. Bit 7 of byte 56 is MSB. Bit 0 of byte 59 is LSB. Rx_PWR(3) should be set to zero for 'internally calibrated' devices.",
    type: "raw", info: {}},
  { addr: 64, bytes: 4, name: "Rx_PWR(2)",
    desc: "Single precision floating point calibration data - Rx optical power. Bit 7 of byte 56 is MSB. Bit 0 of byte 59 is LSB. Rx_PWR(2) should be set to zero for 'internally calibrated' devices.",
    type: "raw", info: {}},
  { addr: 68, bytes: 4, name: "Rx_PWR(1)",
    desc: "Single precision floating point calibration data - Rx optical power. Bit 7 of byte 56 is MSB. Bit 0 of byte 59 is LSB. Rx_PWR(1) should be set to zero for 'internally calibrated' devices.",
    type: "raw", info: {}},
  { addr: 72, bytes: 4, name: "Rx_PWR(0)",
    desc: "Single precision floating point calibration data - Rx optical power. Bit 7 of byte 56 is MSB. Bit 0 of byte 59 is LSB. Rx_PWR(0) should be set to zero for 'internally calibrated' devices.",
    type: "raw", info: {}},
  { addr: 76, bytes: 2, name: "Tx_I(Slope)",
    desc: "Fixed decimal (unsigned) calibration data, laser bias current. Bit 7 of byte 76 is MSB, bit 0 of byte 77 is LSB. Tx_I(Slope) should be set to 1 for 'internally calibrated' devices.",
    type: "unit",
    info: {unit: "", sign: 0, multiplier: "0.00390625"}
  },
  { addr: 78, bytes: 2, name: "Tx_I(Offset)",
    desc: "Fixed decimal (signed two's complement) calibration data, laser bias current. Bit 7 of byte 78 is MSB, bit 0 of byte 79 is LSB. Tx_I(Offset) should be set to zero for 'internally calibrated' devices.",
    type: "unit",
    info: {unit: "mA", sign: 1, multiplier: "0.002"}
  },
  { addr: 80, bytes: 2, name: "Tx_PWR(Slope)",
    desc: "Fixed decimal (unsigned) calibration data, transmitter coupled output power. Bit 7 of byte 80 is MSB, bit 0 of byte 81 is LSB. Tx_PWR(Slope) should be set to 1 for 'internally calibrated' devices.", type: "unit",
    info: {unit: "", sign: 0, multiplier: "0.00390625"}
  },
  { addr: 82, bytes: 2, name: "Tx_PWR(Offset)",
    desc: "Fixed decimal (signed two's complement) calibration data, transmitter coupled output power. Bit 7 of byte 82 is MSB, bit 0 of byte 83 is LSB. Tx_PWR(Offset) should be set to zero for 'internally calibrated' devices.", type: "unit",
    info: {unit: "mW", sign: 1, multiplier: "0.0001"}
  },
  { addr: 84, bytes: 2, name: "T (Slope)",
    desc: "Fixed decimal (unsigned) calibration data, internal module temperature. Bit 7 of byte 84 is MSB, bit 0 of byte 85 is LSB. T(Slope) should be set to 1 for 'internally calibrated' devices.", type: "unit",
    info: {unit: "", sign: 0, multiplier: "0.00390625"}
  },
  { addr: 86, bytes: 2, name: "T (Offset)",
    desc: "Fixed decimal (signed two's complement) calibration data, internal module temperature. Bit 7 of byte 86 is MSB, bit 0 of byte 87 is LSB. T(Offset) should be set to zero for 'internally calibrated' devices.", type: "unit",
    info: {unit: "&#xB0;C", sign: 1, multiplier: "0.00390625"}
  },
  { addr: 88, bytes: 2, name: "V (Slope)",
    desc: "Fixed decimal (unsigned) calibration data, internal module supply voltage. Bit 7 of byte 88 is MSB, bit 0 of byte 89 is LSB. V(Slope) should be set to 1 for 'internally calibrated' devices.", type: "unit",
    info: {unit: "", sign: 0, multiplier: "0.00390625"}
  },
  { addr: 90, bytes: 2, name: "V (Offset)",
    desc: "Fixed decimal (signed two's complement) calibration data, internal module supply voltage. Bit 7 of byte 90 is MSB. Bit 0 of byte 91 is LSB. V(Offset) should be set to zero for 'internally calibrated' devices.", type: "unit",
    info: {unit: "V", sign: 1, multiplier: "0.0001"}
  },
  { addr: 92, bytes: 3, name: "Unallocated", desc: "", type: "raw", info: {}},
  { addr: 95, bytes: 1, name: "Checksum",
    desc: "Byte 95 contains the low order 8 bits of the sum of bytes 0-94.", type: "raw", info: {}},
  { addr: 96, bytes: 2, name: "Temp",
    desc: "Internally measured module temperature.", type: "unit",
    info: {unit: "&#xB0;C", sign: 1, multiplier: "0.00390625"}
  },
  { addr: 98, bytes: 2, name: "Vcc",
    desc: "Internally measured supply voltage in transceiver.", type: "unit",
    info: {unit: "V", sign: 0, multiplier: "0.0001"}
  },
  { addr: 100, bytes: 2, name: "TX Bias",
    desc: "Internally measured TX Bias Current.", type: "unit",
    info: {unit: "mA", sign: 0, multiplier: "0.002"}
  },
  { addr: 102, bytes: 2, name: "TX Power",
    desc: "Measured TX output power.", type: "unit",
    info: {unit: "mW", sign: 0, multiplier: "0.0001"}
  },
  { addr: 104, bytes: 2, name: "RX Power",
    desc: "Measured RX output power.", type: "unit",
    info: {unit: "mW", sign: 0, multiplier: "0.0001"}
  },
  { addr: 106, bytes: 2, name: "Optional Laser Temp/Wavelength",
    desc: "Measured laser temperature or wavelength", type: "unit",
    info: {unit: "&#xB0;C", sign: 1, multiplier: "0.00390625"}
  },
  { addr: 108, bytes: 2, name: "Optional TEC",
    desc: "Measured TEC current (positive is cooling)", type: "unit",
    info: {unit: "mA", sign: 1, multiplier: "0.1"}
  },
  { addr: 110, bytes: 1, name: "Optional Status/Control Bits", desc: "", type: "bits",
    info: [
      {byte_id: 0, bit_id: 7, desc: "TX Disable State",
       det: "Digital state of the TX Disable Input Pin. Updated within 100ms of change on pin."},
      {byte_id: 0, bit_id: 6, desc: "Soft TX Disable Select",
       det: "Read/write bit that allows software disable of laser. Writing '1' disables laser. See Table 8-7 for enable/disable timing requirements. This bit is 'OR'd with the hard TX_DISABLE pin value. Note, per SFP MSA TX_DISABLE pin is default enabled unless pulled low by hardware. If Soft TX Disable is not implemented, the transceiver ignores the value of this bit. Default power up value is zero/low."},
      {byte_id: 0, bit_id: 5, desc: "RS(1) State",
       det: "Digital state of SFP input pin AS(1) per SFF-8079 or RS(1) per SFF-8431. Updated within 100ms of change on pin. See A2h Byte 118, Bit 3 for Soft RS(1) Select control information."},
      {byte_id: 0, bit_id: 4, desc: "Rate_Select State RS(0)",
       det: "Digital state of the SFP Rate_Select Input Pin. Updated within 100ms of change on pin. Note: This pin is also known as AS(0) in SFF-8079 and RS(0) in SFF-8431."},
      {byte_id: 0, bit_id: 3, desc: "Soft Rate_Select Select RS(0)",
       det: "Read/write bit that allows software rate select control. Writing '1' selects full bandwidth operation. This bit is 'OR'd with the hard Rate_Select, AS(0) or RS(0) pin value. See Table 8-7 for timing requirements. Default at power up is 0/low, unless specifically redefined by value selected in Table 5-6. If Soft Rate Select is not implemented, the transceiver ignores the value of this bit. Note: Specific transceiver behaviors of this bit are identified in Table 5-6 and referenced documents. See Table 10-1, byte 118, bit 3 for Soft RS(1) Select."},
      {byte_id: 0, bit_id: 2, desc: "TX Fault State",
       det: "Digital state of the TX Fault Output Pin. Updated within 100ms of change on pin."},
      {byte_id: 0, bit_id: 1, desc: "Rx_LOS State",
       det: "Digital state of the RX_LOS Output Pin. Updated within 100ms of change on pin."},
      {byte_id: 0, bit_id: 0, desc: "Data_Ready_Bar State",
       det: "Indicates transceiver has achieved power up and data is ready. Bit remains high until data is ready to be read at which time the device sets the bit low."}]
  },
  { addr: 111, bytes: 1, name: "Reserved", desc: "Reserved for SFF-8079.", type: "raw", info: {}},
  { addr: 112, bytes: 2, name: "Alarm Flags", desc: "Diagnostic Alarm Flag Status Bits", type: "bits",
    info: [
      {byte_id: 0, bit_id: 7, desc: "Temp High Alarm", det: "Set when internal temperature exceeds high alarm level."},
      {byte_id: 0, bit_id: 6, desc: "Temp Low Alarm", det: "Set when internal temperature is below low alarm level."},
      {byte_id: 0, bit_id: 5, desc: "Vcc High Alarm", det: "Set when internal supply voltage exceeds high alarm level."},
      {byte_id: 0, bit_id: 4, desc: "Vcc Low Alarm", det: "Set when internal supply voltage is below low alarm level."},
      {byte_id: 0, bit_id: 3, desc: "TX Bias High Alarm", det: "Set when TX Bias current exceeds high alarm level."},
      {byte_id: 0, bit_id: 2, desc: "TX Bias Low Alarm", det: "Set when TX Bias current is below low alarm level."},
      {byte_id: 0, bit_id: 1, desc: "TX Power High Alarm", det: "Set when TX output power exceeds high alarm level."},
      {byte_id: 0, bit_id: 0, desc: "TX Power Low Alarm", det: "Set when TX output power is below low alarm level."},

      {byte_id: 1, bit_id: 7, desc: "RX Power High Alarm", det: "Set when Received Power exceeds high alarm level."},
      {byte_id: 1, bit_id: 6, desc: "RX Power Low Alarm", det: "Set when Received Power is below low alarm level."},
      {byte_id: 1, bit_id: 5, desc: "Optional Laser Temp High Alarm", det: "Set when laser temperature or wavelength exceeds the high alarm level."},
      {byte_id: 1, bit_id: 4, desc: "Optional Laser Temp Low Alarm", det: "Set when laser temperature or wavelength is below the low alarm level."},
      {byte_id: 1, bit_id: 3, desc: "Optional TEC current High Alarm", det: "Set when TEC current exceeds the high alarm level."},
      {byte_id: 1, bit_id: 2, desc: "Optional TEC current Low Alarm", det: "Set when TEC current is below the low alarm level."},
      {byte_id: 1, bit_id: 1, desc: "Reserved Alarm", det: ""},
      {byte_id: 1, bit_id: 0, desc: "Reserved Alarm", det: ""}]
  },
  { addr: 114, bytes: 1, name: "Tx input equalization", desc: "", type: "raw", info: {}},
  { addr: 115, bytes: 1, name: "RX output emphasis", desc: "", type: "raw", info: {}},
  { addr: 116, bytes: 2, name: "Warning Flags", desc: "Diagnostic Warning Flag Status Bits", type: "bits",
    info: [
      {byte_id: 0, bit_id: 7, desc: "Temp High Warning", det: "Set when internal temperature exceeds high warning level."},
      {byte_id: 0, bit_id: 6, desc: "Temp Low Warning", det: "Set when internal temperature is below low warning level."},
      {byte_id: 0, bit_id: 5, desc: "Vcc High Warning", det: "Set when internal supply voltage exceeds high warning level."},
      {byte_id: 0, bit_id: 4, desc: "Vcc Low Warning", det: "Set when internal supply voltage is below low warning level."},
      {byte_id: 0, bit_id: 3, desc: "TX Bias High Warning", det: "Set when TX Bias current exceeds high warning level."},
      {byte_id: 0, bit_id: 2, desc: "TX Bias Low Warning", det: "Set when TX Bias current is below low warning level."},
      {byte_id: 0, bit_id: 1, desc: "TX Power High Warning", det: "Set when TX output power exceeds high warning level."},
      {byte_id: 0, bit_id: 0, desc: "TX Power Low Warning", det: "Set when TX output power is below low warning level."},

      {byte_id: 1, bit_id: 7, desc: "RX Power High Warning", det: "Set when Received Power exceeds high warning level."},
      {byte_id: 1, bit_id: 6, desc: "RX Power Low Warning", det: "Set when Received Power is below low warning level."},
      {byte_id: 1, bit_id: 5, desc: "Optional Laser Temp High Warning", det: "Set when laser temperature or wavelength exceeds the high warning level."},
      {byte_id: 1, bit_id: 4, desc: "Optional Laser Temp Low Warning", det: "Set when laser temperature or wavelength is below the low warning level."},
      {byte_id: 1, bit_id: 3, desc: "Optional TEC current High Warning", det: "Set when TEC current exceeds the high warning level."},
      {byte_id: 1, bit_id: 2, desc: "Optional TEC current Low Warning", det: "Set when TEC current is below the low warning level."},
      {byte_id: 1, bit_id: 1, desc: "Reserved Warning", det: ""},
      {byte_id: 1, bit_id: 0, desc: "Reserved Warning", det: ""}]
  },
  { addr: 118, bytes: 2, name: "Ext Status/Control", desc: "Extended module control and status bytes", type: "bits",
    info: [
      {byte_id: 0, bit_id: 7, desc: "Reserved", det: ""},
      {byte_id: 0, bit_id: 6, desc: "Reserved", det: ""},
      {byte_id: 0, bit_id: 5, desc: "Reserved", det: ""},
      {byte_id: 0, bit_id: 4, desc: "Reserved", det: ""},
      {byte_id: 0, bit_id: 3, desc: "Soft RS(1) Select",
       det: "Read/write bit that allows software Tx rate control. Writing '1' selects full speed Tx operation. This bit is 'OR'd with the hard RS(1) pin value. See Table 8-7 for timing requirements. Default at power up is 0/low, unless specifically redefined by value selected in Table 5-6. If Soft RS(1) is not implemented, the transceiver ignores the value of this bit. Note: Specific transceiver behaviors of this bit are identified in Table 5-6 and referenced documents. See Table 9-11, byte 110, bit 3 for Soft RS(0) Select."},
      {byte_id: 0, bit_id: 2, desc: "Reserved", det: ""},
      {byte_id: 0, bit_id: 1, desc: "Power Level Operation State",
       det: "Optional. SFF-8431 Power Level (maximum power dissipation) status. Value of zero indicates Power Level 1 operation (1.0 Watt max). Value of one indicates Power Level 2 or 3 operation (1.5 or 2.0 Wat max), depending on the values in byte 64 of A0h. Refer to Table 8-3 for Power Level requirement declaration. Refer to Table 8-7 for timing."},
      {byte_id: 0, bit_id: 0, desc: "Power Level Select",
       det: "Optional. SFF-8431 Power Level (maximum power dissipation) control bit. Value of zero enables Power Level 1 only (1.0 Watt max). Value of one enables Power Level 2 or 3 (1.5 or 2.0 Watt max), depending on the values in byte 64 of A0h. Refer to Table 8-3 for Power Level requirement declaration. Refer to Table 8-7 for timing. If Power Levels 2 or 3 are not implemented, the SFP ignores the valu of this bit."},
      {byte_id: 1, bit_id: 7, desc: "Reserved", det: ""},
      {byte_id: 1, bit_id: 6, desc: "Reserved", det: ""},
      {byte_id: 1, bit_id: 5, desc: "Reserved", det: ""},
      {byte_id: 1, bit_id: 4, desc: "64GFC Mode Tx Configured",
       det: "This status bit is a response to the 64GFC mode control bit. The bit indicates the module Tx logic has finished configuring itself to 64GFC mode at 28.9 GBd."},
      {byte_id: 1, bit_id: 3, desc: "64GFC Mode Rx Configured",
       det: "This status bit is a response to the 64GFC mode control bit. The bit indicates the module Rx logic has finished configuring itself to 64GFC mode at 28.9 GBd."},
      {byte_id: 1, bit_id: 2, desc: "64GFC Mode",
       det: "Writing a 1 to this bit selects 64GFC speed of operation at 28.9 GBd. When this bit is set to 1, the rate select settings on the pins or in the registers shall be ignored. Default at power up for this bit is 0."},
      {byte_id: 1, bit_id: 1, desc: "Optional Tx CDR unlocked",
       det: "Used when bit 64.3 (A0h) is set to 1. If the Tx side CDR is enabled, a value of 0 indicates that the CDR is locked, whereas a value of 1 indicates loss of lock of the CDR. If the CDR is in bypass mode this bit is set to 0. In 64GFC mode, if bit 4 of this byte is set to 1, a value of 0 indicates that the equalizer has finished adaptation and the CDR is locked to the PAM4 signal."},
      {byte_id: 1, bit_id: 0, desc: "Optional Rx CDR unlocked",
       det: "Used when bit 64.3 (A0h) is set to 1. If the Rx side CDR is enabled, a value of 0 indicates that the CDR is locked, whereas a value of 1 indicates loss of lock of the CDR. If the CDR is in bypass mode this bit is set to 0. In 64GFC mode, if bit 3 of this byte is set to 1, a value of 0 indicates that the equalizer has finished adaptation and the CDR is locked to the PAM4 signal."}]
  },
  { addr: 120, bytes: 7, name: "Vendor Specific", desc: "Vendor specific memory addresses", type: "raw", info: {}},
  { addr: 127, bytes: 1, name: "Optional Page Select",
    desc: "Defines the page number for subsequent reads and writes to locations A2h<128-255>", type: "raw", info: {}},
  { addr: 128, bytes: 128, name: "Page", desc: "based on Optional Page Select", type: "raw", info: {}}
];
